/* Copyright 1989, 1990 by James Aspnes, David Applegate, and Bennet Yee */
/* See the file COPYING for distribution information */
#include "db.h"
#include "globals.h"
#include "externs.h"

datum create (void)
{
  datum obj;

  if (!flag_set (me, F_WIZARD)) {
    return NOTHING;
  } else {
    obj = new_object (me);
    return obj;
  }
}

datum destroy (datum thing)
{
  /* note special safety feature */
  if (!flag_set (me, F_WIZARD) || thing == you || !controls (me, thing)) {
    return 0;
  } else {
    /* nuke it */
    free_object (thing);
    return 1;
  }
}
