/* Copyright 1989, 1990 by James Aspnes, David Applegate, and Bennet Yee */
/* See the file COPYING for distribution information */
#ifndef GLOBALS_H
#define GLOBALS_H

#include "db.h"

extern datum me;                /* receiver of op */
extern datum you;               /* agent */
extern datum text;              /* unmatched text */
extern datum mtext;             /* matched text */

#define PUSH_GLOBALS \
    { datum _me, _you, _text, _mtext; \
      _me = me; _you = you; _text = text; _mtext = mtext; {
#define POP_GLOBALS } me = _me; you = _you; text = _text; mtext = _mtext; }

extern int no_delays;           /* disables delay for non-wizards */

extern int please_gc;           /* if 1, gc as soon as it's safe */
extern int please_checkpoint;   /* if 1, checkpoint ditto */

#endif /* GLOBALS_H */
