/* Copyright 1989, 1990 by James Aspnes, David Applegate, and Bennet Yee */
/* See the file COPYING for distribution information */
#include <stdio.h>

/* Sends stdin to stdout, replacing blank lines with '\n' */
/* and all other newlines with tabs */
int main ()
{
  int c;

  while ((c = getchar ()) != EOF) {
    if (c == '\n') {
      putchar ('\t');
      if ((c = getchar ()) == EOF)
        break;
      putchar (c);
    } else {
      putchar (c);
    }
  }

  putchar ('\n');
  return (0);
}
